Package org.flowable.task.api

# Interface TaskQuery

All Superinterfaces:
  `Query<TaskQuery,Task>`, `TaskInfoQuery<TaskQuery,Task>`

public interface TaskQuery extends TaskInfoQuery<TaskQuery,Task>
Allows programmatic querying of `Task`s;

Author:
  Joram Barrez, Falko Menge, Tijs Rademakers

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface org.flowable.common.engine.api.query.Query

  `Query.NullHandlingOnOrder`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `TaskQuery`
  `active()`
  Only selects tasks which are active (ie. not suspended)
  `TaskQuery`
  `excludeSubtasks()`
  Only select tasks that have no parent (i.e. do not select subtasks).
  `TaskQuery`
  `suspended()`
  Only selects tasks which are suspended, because its process instance was suspended.
  `TaskQuery`
  `taskCandidateOrAssigned(String userIdForCandidateAndAssignee)`
  Select tasks that has been claimed or assigned to user or waiting to claim by user (candidate user or groups).
  `TaskQuery`
  `taskDelegationState(DelegationState delegationState)`
  Only select tasks with the given `DelegationState`.

  ### Methods inherited from interface org.flowable.common.engine.api.query.Query

  `asc, count, desc, list, listPage, orderBy, orderBy, singleResult`

  ### Methods inherited from interface org.flowable.task.api.TaskInfoQuery

  `caseDefinitionId, caseDefinitionKey, caseDefinitionKeyIn, caseDefinitionKeyLike, caseDefinitionKeyLikeIgnoreCase, caseInstanceId, caseInstanceIdWithChildren, caseVariableExists, caseVariableNotExists, caseVariableValueEquals, caseVariableValueEquals, caseVariableValueEqualsIgnoreCase, caseVariableValueGreaterThan, caseVariableValueGreaterThanOrEqual, caseVariableValueLessThan, caseVariableValueLessThanOrEqual, caseVariableValueLike, caseVariableValueLikeIgnoreCase, caseVariableValueNotEquals, caseVariableValueNotEqualsIgnoreCase, cmmnDeploymentId, cmmnDeploymentIdIn, deploymentId, deploymentIdIn, endOr, executionId, ignoreAssigneeValue, includeCaseVariables, includeIdentityLinks, includeProcessVariables, includeTaskLocalVariables, locale, or, orderByCategory, orderByDueDateNullsFirst, orderByDueDateNullsLast, orderByExecutionId, orderByProcessDefinitionId, orderByProcessInstanceId, orderByTaskAssignee, orderByTaskCreateTime, orderByTaskDefinitionKey, orderByTaskDescription, orderByTaskDueDate, orderByTaskId, orderByTaskName, orderByTaskOwner, orderByTaskPriority, orderByTenantId, planItemInstanceId, processCategoryIn, processCategoryNotIn, processDefinitionId, processDefinitionKey, processDefinitionKeyIn, processDefinitionKeyLike, processDefinitionKeyLikeIgnoreCase, processDefinitionName, processDefinitionNameLike, processInstanceBusinessKey, processInstanceBusinessKeyLike, processInstanceBusinessKeyLikeIgnoreCase, processInstanceId, processInstanceIdIn, processInstanceIdWithChildren, processVariableExists, processVariableNotExists, processVariableValueEquals, processVariableValueEquals, processVariableValueEqualsIgnoreCase, processVariableValueGreaterThan, processVariableValueGreaterThanOrEqual, processVariableValueLessThan, processVariableValueLessThanOrEqual, processVariableValueLike, processVariableValueLikeIgnoreCase, processVariableValueNotEquals, processVariableValueNotEqualsIgnoreCase, propagatedStageInstanceId, scopeDefinitionId, scopeId, scopeType, subScopeId, taskAssigned, taskAssignee, taskAssigneeIds, taskAssigneeLike, taskAssigneeLikeIgnoreCase, taskCandidateGroup, taskCandidateGroupIn, taskCandidateUser, taskCategory, taskCategoryIn, taskCategoryNotIn, taskClaimedAfter, taskClaimedBefore, taskClaimedBy, taskClaimedOn, taskCreatedAfter, taskCreatedBefore, taskCreatedOn, taskDefinitionId, taskDefinitionKey, taskDefinitionKeyLike, taskDefinitionKeys, taskDescription, taskDescriptionLike, taskDescriptionLikeIgnoreCase, taskDueAfter, taskDueBefore, taskDueDate, taskFormKey, taskId, taskIds, taskInProgressStartDueAfter, taskInProgressStartDueBefore, taskInProgressStartDueDate, taskInProgressStartedBy, taskInProgressStartTimeAfter, taskInProgressStartTimeBefore, taskInProgressStartTimeOn, taskInvolvedGroups, taskInvolvedUser, taskMaxPriority, taskMinPriority, taskName, taskNameIn, taskNameInIgnoreCase, taskNameLike, taskNameLikeIgnoreCase, taskOwner, taskOwnerLike, taskOwnerLikeIgnoreCase, taskParentScopeId, taskPriority, taskRootScopeId, taskState, taskSuspendedAfter, taskSuspendedBefore, taskSuspendedBy, taskSuspendedOn, taskTenantId, taskTenantIdLike, taskUnassigned, taskVariableExists, taskVariableNotExists, taskVariableValueEquals, taskVariableValueEquals, taskVariableValueEqualsIgnoreCase, taskVariableValueGreaterThan, taskVariableValueGreaterThanOrEqual, taskVariableValueLessThan, taskVariableValueLessThanOrEqual, taskVariableValueLike, taskVariableValueLikeIgnoreCase, taskVariableValueNotEquals, taskVariableValueNotEqualsIgnoreCase, taskWithFormKey, taskWithoutCategory, taskWithoutTenantId, withLocalizationFallback, withoutProcessInstanceId, withoutScopeId, withoutTaskDueDate, withoutTaskInProgressStartDueDate`

- ## Method Details

  - ### taskDelegationState

    TaskQuery taskDelegationState(DelegationState delegationState)
    Only select tasks with the given `DelegationState`.

  - ### taskCandidateOrAssigned

    TaskQuery taskCandidateOrAssigned(String userIdForCandidateAndAssignee)
    Select tasks that has been claimed or assigned to user or waiting to claim by user (candidate user or groups). You can invoke `TaskInfoQuery.taskCandidateGroupIn(Collection)` to include tasks that can be claimed by a user in the given groups while set property dbIdentityUsed to false in process engine configuration or using custom session factory of GroupIdentityManager.

  - ### excludeSubtasks

    TaskQuery excludeSubtasks()
    Only select tasks that have no parent (i.e. do not select subtasks).

  - ### suspended

    TaskQuery suspended()
    Only selects tasks which are suspended, because its process instance was suspended.

  - ### active

    TaskQuery active()
    Only selects tasks which are active (ie. not suspended)